//---------------------------------------------------------------------
// SPACE TAPPER: data.h
// by Omar Cornut
//---------------------------------------------------------------------
// Embedded Data
//---------------------------------------------------------------------

// Layer: Font
extern const unsigned char 	font_Bitmap[4096];

// Layer: Title Screen
// extern const unsigned short title_Palette[];
// extern const unsigned short title_Map[];
// extern const unsigned char  title_Tiles[27904];
// extern const unsigned char  title_logo_Bitmap[4928];
extern const unsigned short title2_Palette[256];
extern const unsigned short title2_Map[600];
extern const unsigned char  title2_Tiles[17344];
extern const unsigned short title2_stars_Map[100];
extern const unsigned char  title2_stars_Tiles[704];
extern const unsigned char  title2_window_Bitmap[49152];

// Layer: Game Over Screen
extern const unsigned short gameover_Palette[];
extern const unsigned short	gameover_Map[];
extern const unsigned char	gameover_Tiles[16192];

// Sprites: Game Over Letters
extern const unsigned short gameover_letters_Palette[256];
extern const unsigned char	gameover_letters_Bitmap[8192];

// Layer: Layout 1 + Tappers + Money
extern const unsigned short l1_layout_Palette[];
extern const unsigned short l1_layout_Map[];
extern const unsigned char  l1_layout_Tiles[21440];
extern const unsigned char 	l1_layout_bars_start_Bitmap[768];
extern const unsigned char 	l1_layout_bars_repeat_Bitmap[768];
extern const unsigned short	l1_tapper_Palette[16];
extern const unsigned char	l1_tapper_Bitmap[1024];
extern const unsigned short l1_money_Palette[16];
extern const unsigned char 	l1_money_Bitmap[32*9];

// Layer: Layout 2 + Tappers + Money + Alien
extern const unsigned short l2_layout_Palette[];
extern const unsigned short l2_layout_Map[];
extern const unsigned char  l2_layout_Tiles[28992];
extern const unsigned char 	l2_layout_bars_start_Bitmap[768];
extern const unsigned char 	l2_layout_bars_repeat_Bitmap[768];
extern const unsigned short	l2_tapper_Palette[16];
extern const unsigned char	l2_tapper_Bitmap[1024];
extern const unsigned short l2_money_Palette[16];
extern const unsigned char 	l2_money_Bitmap[32*9];

// Layer: Layout 3 + Platform
extern const unsigned short l3_layout_Palette[];
extern const unsigned short l3_layout_Map[];
extern const unsigned char  l3_layout_Tiles[28032];
extern const unsigned char 	l3_layout_bars_start_Bitmap[768];
extern const unsigned char 	l3_layout_bars_repeat_Bitmap[768];
extern const unsigned short l3_layout_platform_Map[100];
extern const unsigned char	l3_layout_platform_Tiles[3392];

// Layer: Layout 5 + Part
extern const unsigned short l5_layout_Palette[];
extern const unsigned short l5_layout_Map[];
extern const unsigned char  l5_layout_Tiles[21056];
extern const unsigned char 	l5_layout_bars_start_Bitmap[768];
extern const unsigned char 	l5_layout_bars_repeat_Bitmap[768];
extern const unsigned char  l5_layout_part_Bitmap[960];

// Layer: Entertainers
extern const unsigned short	entertainers_Palette[256];
extern const unsigned char	entertainers_Bitmap[3456*4];

// Sprites: Aliens
extern const unsigned short alien1_Palette[16];
extern const unsigned char  alien1_Bitmap[];
extern const unsigned short alien2_Palette[16];
extern const unsigned char  alien2_Bitmap[];
extern const unsigned short alien3_Palette[16];
extern const unsigned char  alien3_Bitmap[];
extern const unsigned short alien5_Palette[16];
extern const unsigned char  alien5_Bitmap[];
extern const unsigned short alien6_Palette[16];
extern const unsigned char  alien6_Bitmap[];
extern const unsigned short alien7_Palette[16];
extern const unsigned char  alien7_Bitmap[];
extern const unsigned short alien8_Palette[16];
extern const unsigned char  alien8_Bitmap[];

// Sprites: Beer
extern const unsigned short beer_Palette[16];
extern const unsigned char 	beer_Bitmap[2112];

// Sprites: Bartender
extern const unsigned short bartender_Palette[16];
extern const unsigned char 	bartender_Bitmap[];

// Sprites: Lives Icon
extern const unsigned char	lives_Bitmap[];

// Sprites: Pause // FIXME ...
extern const unsigned char  pause_Bitmap[160];
extern const unsigned short pause_Palette[16];

// Sprites: Level 2 Tube Alien + Bubbles
extern const unsigned short	l2_tubealien_Palette[16];
extern const unsigned char	l2_tubealien_Bitmap[3072];
extern const unsigned short	l2_tubealien_bubbles_Palette[16];
extern const unsigned char	l2_tubealien_bubbles_Bitmap[1024];

// Animations
extern const u8				data_alien1_anim_set[];
extern const u8				data_alien2_anim_set[];
extern const u8				data_alien3_anim_set[];
extern const u8				data_alien5_anim_set[];
extern const u8				data_alien6_anim_set[];
extern const u8				data_alien7_anim_set[];
extern const u8				data_alien8_anim_set[];
extern const u8				data_bartender_anim_set[];
extern const u8				data_beer_anim_set[];
extern const u8				data_entertainers_anim_set[];
extern const u8             data_money_anim_set[];
extern const u8             data_tapper_anim_set[];
extern const u8             data_title2_window_anim_set[];
extern const u8             data_tubealien_anim_set[];
extern const u8             data_tubealien_bubbles_anim_set[];

//---------------------------------------------------------------------
