//---------------------------------------------------------------------
// SPACE TAPPER: data_levels.c
// by Omar Cornut
//---------------------------------------------------------------------
// Levels Data
//---------------------------------------------------------------------

#define SEQUENCER_INSTRUCTIONS_NEEDED
#include "tapper.h"

//---------------------------------------------------------------------
// See "game_levels_sequencer.h" for instructions documentation
//---------------------------------------------------------------------

//---------------------------------------------------------------------
// SEQUENCES
//---------------------------------------------------------------------

const u8				level_empty_sequence[] =
{
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		20,
	
	0,					SEQUENCE_ALIEN,		BAR(1), ALIEN(1),
	0,					SEQUENCE_ALIEN,		BAR(2), ALIEN(2),
	0,					SEQUENCE_ALIEN,		BAR(3), ALIEN(3),
	0,					SEQUENCE_ALIEN,		BAR(4), ALIEN(4),
	
	0,					SEQUENCE_END
};

const u8				level_TEST_alien4_sequence[] =
{
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		20,
	
	0,					SEQUENCE_ALIEN,		BAR(1), ALIEN(4),
	0,					SEQUENCE_ALIEN,		BAR(2), ALIEN(4),
	0,					SEQUENCE_ALIEN,		BAR(3), ALIEN(4),
	0,					SEQUENCE_ALIEN,		BAR(4), ALIEN(4),
	0,					SEQUENCE_DELAY,		100,
	0,					SEQUENCE_ALIEN,		BAR(1), ALIEN(4),
	0,					SEQUENCE_ALIEN,		BAR(2), ALIEN(4),
	0,					SEQUENCE_ALIEN,		BAR(3), ALIEN(4),
	0,					SEQUENCE_ALIEN,		BAR(4), ALIEN(4),
	
	0,					SEQUENCE_END
};

const u8				level_1_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		15,
                                            
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(1),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		10,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3),	ALIEN(1),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		20,
	                                        
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(2),
	     NORMAL|HARD,	SEQUENCE_DELAY,		10,
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(2),
	     NORMAL|HARD,	SEQUENCE_DELAY,		20,
                                            
	            HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(1),
	            HARD,	SEQUENCE_DELAY,		10,
	            HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(1),
	            HARD,	SEQUENCE_DELAY,		10,
	
	0,					SEQUENCE_END
};

const u8				level_2_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		15,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(1),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		10,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2),	ALIEN(2),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		10,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3),	ALIEN(1),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		10,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4),	ALIEN(2),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		50,

    EASY            ,	SEQUENCE_ENTERTAIN,	40,
         NORMAL     ,	SEQUENCE_ENTERTAIN,	50,
                HARD,	SEQUENCE_ENTERTAIN,	60,
	
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(2),
	     NORMAL|HARD,	SEQUENCE_DELAY,		10,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(3),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		10,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(3),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		10,
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(1),
	     NORMAL|HARD,	SEQUENCE_DELAY,		10,
	
    EASY            ,	SEQUENCE_ENTERTAIN,	40,
         NORMAL     ,	SEQUENCE_ENTERTAIN,	50,
                HARD,	SEQUENCE_ENTERTAIN,	60,
	
	            HARD,	SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(1),
	            HARD,	SEQUENCE_DELAY,		10,
	            HARD,	SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(2),
	
	0,					SEQUENCE_END
};

const u8				level_3_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		15,

                HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(3),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(3),	
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(4),	
         NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4),	ALIEN(3),
         
    0,					SEQUENCE_DELAY,		100,

    EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(4),
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(3),	
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(2),	
    EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4),	ALIEN(1),

		 NORMAL|HARD,	SEQUENCE_DELAY,		30,
         NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(3), ALIEN(1),
                HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(2),

    0,					SEQUENCE_DELAY,		40,
    0,					SEQUENCE_WAIT_COUNT,BAR_ALL, 4,

	EASY            ,	SEQUENCE_ALIEN,		BAR(1), ALIEN(1),
         NORMAL|HARD,   SEQUENCE_ALIEN,		BAR(1), ALIEN(4),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(4),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(4),
	EASY|NORMAL     ,	SEQUENCE_ALIEN,		BAR(4), ALIEN(1),
                HARD,   SEQUENCE_ALIEN,		BAR(4), ALIEN(4),

		 NORMAL|HARD,	SEQUENCE_DELAY,		20,
         NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(1),
                HARD,   SEQUENCE_ALIEN,     BAR(2), ALIEN(2),

	0,					SEQUENCE_END
};

const u8				level_4_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		15,
	
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(1),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(1),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		20,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(5),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(5),
	
	EASY            ,	SEQUENCE_DELAY,     110,
	     NORMAL     ,	SEQUENCE_DELAY,		90,
	            HARD,	SEQUENCE_DELAY,		80,

    EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(4),
    EASY|NORMAL|HARD,	SEQUENCE_DELAY,		20,
         NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(4),
         NORMAL|HARD,	SEQUENCE_DELAY,		30,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(2),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(2),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		20,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(3),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(3),

	EASY            ,	SEQUENCE_VAR_SET,   VAR(1), 5,
	     NORMAL     ,	SEQUENCE_VAR_SET,   VAR(1), 7,
	            HARD,	SEQUENCE_VAR_SET,   VAR(1), 9,
	EASY|NORMAL|HARD,	SEQUENCE_LABEL_SET,	LOOP(1),
    EASY|NORMAL|HARD,	SEQUENCE_DELAY,		40,
    EASY|NORMAL|HARD,	SEQUENCE_WAIT_COUNT,BAR_ALL, 6,
	EASY|NORMAL|HARD,   SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(4),
    EASY|NORMAL|HARD,	SEQUENCE_DJNZ,		VAR(1), LOOP(1),

         NORMAL|HARD,	SEQUENCE_DELAY,		45,
         NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(5),
         NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(5),
                HARD,	SEQUENCE_DELAY,		45,
                HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(3),
                HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(3),
	
	0,					SEQUENCE_END
};

const u8				level_5_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		20,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(6),

	EASY            ,	SEQUENCE_DELAY,		80,
	     NORMAL     ,	SEQUENCE_DELAY,		70,
	            HARD,	SEQUENCE_DELAY,		60,

	EASY            ,	SEQUENCE_VAR_SET,	VAR(1), 4,
	     NORMAL     ,	SEQUENCE_VAR_SET,	VAR(1), 5,
	            HARD,	SEQUENCE_VAR_SET,	VAR(1), 6,
	EASY|NORMAL|HARD,	SEQUENCE_LABEL_SET,	LOOP(1),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(2)|ALIEN(3)|ALIEN(5),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		30,
	EASY|NORMAL|HARD,	SEQUENCE_DJNZ,		VAR(1), LOOP(1),

    // FIXME: test
	0,                  SEQUENCE_ENTERTAIN, 60,

	EASY            ,	SEQUENCE_DELAY,		60,
	     NORMAL     ,	SEQUENCE_DELAY,		50,
	            HARD,	SEQUENCE_DELAY,		40,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(6),
	
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(2)|ALIEN(3)|ALIEN(4)|ALIEN(5),
	     NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(2)|ALIEN(3)|ALIEN(4)|ALIEN(5),

	EASY            ,	SEQUENCE_DELAY,		50,
	     NORMAL     ,	SEQUENCE_DELAY,		50,
	            HARD,	SEQUENCE_DELAY,		40,

                HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(6),
    EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(2), ALIEN(4),
    EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(3), ALIEN(4),
         NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(2),
         
    EASY|NORMAL|HARD,	SEQUENCE_DELAY,		70,

	EASY            ,	SEQUENCE_VAR_SET,	VAR(1), 4,
	     NORMAL     ,	SEQUENCE_VAR_SET,	VAR(1), 5,
	            HARD,	SEQUENCE_VAR_SET,	VAR(1), 6,
	EASY|NORMAL|HARD,	SEQUENCE_LABEL_SET,	LOOP(1),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		30,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(2)|ALIEN(3)|ALIEN(4)|ALIEN(5),
	EASY|NORMAL|HARD,	SEQUENCE_DJNZ,		VAR(1), LOOP(1),

	0,					SEQUENCE_END
};

const u8				level_6_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		20,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(6),

	EASY            ,	SEQUENCE_DELAY,		80,
	     NORMAL     ,	SEQUENCE_DELAY,		70,
	            HARD,	SEQUENCE_DELAY,		60,

	EASY            ,	SEQUENCE_VAR_SET,	VAR(1), 3,
	     NORMAL     ,	SEQUENCE_VAR_SET,	VAR(1), 4,
	            HARD,	SEQUENCE_VAR_SET,	VAR(1), 4,
	EASY|NORMAL|HARD,	SEQUENCE_LABEL_SET,	LOOP(1),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		30,
	EASY|NORMAL|HARD,	SEQUENCE_DJNZ,		VAR(1), LOOP(1),

	0,                  SEQUENCE_ENTERTAIN, 60,

	EASY            ,	SEQUENCE_DELAY,		120,
	     NORMAL     ,	SEQUENCE_DELAY,		100,
	            HARD,	SEQUENCE_DELAY,		80,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(1), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(4), ALIEN(6),

	EASY            ,	SEQUENCE_DELAY,		120,
	     NORMAL     ,	SEQUENCE_DELAY,		100,
	            HARD,	SEQUENCE_DELAY,		80,

	0,                  SEQUENCE_ENTERTAIN, 60,

	EASY            ,	SEQUENCE_DELAY,		60,
	     NORMAL     ,	SEQUENCE_DELAY,		50,
	            HARD,	SEQUENCE_DELAY,		40,

	EASY            ,	SEQUENCE_VAR_SET,	VAR(1), 3,
	     NORMAL     ,	SEQUENCE_VAR_SET,	VAR(1), 4,
	            HARD,	SEQUENCE_VAR_SET,	VAR(1), 4,
	EASY|NORMAL|HARD,	SEQUENCE_LABEL_SET,	LOOP(1),
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR_RANDOM, ALIEN(6),
	EASY|NORMAL|HARD,	SEQUENCE_DELAY,		30,
	EASY|NORMAL|HARD,	SEQUENCE_DJNZ,		VAR(1), LOOP(1),

	0,					SEQUENCE_END
};

const u8				level_7_sequence[] =
{
	0,					SEQUENCE_LABEL_SET,	LOOP(0),			// Start
	0,					SEQUENCE_DELAY,		20,

	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(2), ALIEN(7),
	EASY            ,	SEQUENCE_DELAY,		60,
	     NORMAL     ,	SEQUENCE_DELAY,		50,
	            HARD,	SEQUENCE_DELAY,		40,
	EASY|NORMAL|HARD,	SEQUENCE_ALIEN,		BAR(3), ALIEN(7),

	EASY            ,	SEQUENCE_DELAY,		80,
	     NORMAL     ,	SEQUENCE_DELAY,		70,
	            HARD,	SEQUENCE_DELAY,		60,

    EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(1)|ALIEN(4)|ALIEN(5),
    EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(1)|ALIEN(4)|ALIEN(5),
         NORMAL|HARD,   SEQUENCE_DELAY,     60,
         NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(1)|ALIEN(4)|ALIEN(5),
         NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(1)|ALIEN(4)|ALIEN(5),

    EASY|NORMAL     ,   SEQUENCE_ALIEN,     BAR(2)|BAR(3), ALIEN(6),
                HARD,   SEQUENCE_ALIEN,     BAR(2), ALIEN(6),
                HARD,   SEQUENCE_ALIEN,     BAR(3), ALIEN(6),

                HARD,   SEQUENCE_DELAY,     60,
                HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(1)|ALIEN(4)|ALIEN(5),
                HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(1)|ALIEN(4)|ALIEN(5),

	EASY            ,	SEQUENCE_DELAY,		120,
	     NORMAL     ,	SEQUENCE_DELAY,		100,
	            HARD,	SEQUENCE_DELAY,		 80,

    EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(2)|BAR(3), ALIEN(6),

    EASY            ,   SEQUENCE_ALIEN,     BAR(1), ALIEN(1)|ALIEN(4)|ALIEN(5),
    EASY            ,   SEQUENCE_ALIEN,     BAR(4), ALIEN(1)|ALIEN(4)|ALIEN(5),
         NORMAL     ,   SEQUENCE_ALIEN,     BAR(1), ALIEN(1)|ALIEN(4)|ALIEN(5),
         NORMAL     ,   SEQUENCE_ALIEN,     BAR(4), ALIEN(4)|ALIEN(5),
                HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(4)|ALIEN(5),
                HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(4)|ALIEN(5),

	EASY            ,	SEQUENCE_DELAY,		120,
	     NORMAL     ,	SEQUENCE_DELAY,		100,
	            HARD,	SEQUENCE_DELAY,		 80,
	            
	     NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(7),
	EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(2), ALIEN(7),
	EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(3), ALIEN(7),
	     NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(7),

	EASY            ,	SEQUENCE_DELAY,		120,
	     NORMAL     ,	SEQUENCE_DELAY,		100,
	            HARD,	SEQUENCE_DELAY,		 70,

	     NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(1), ALIEN(4),
	EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(2), ALIEN(4),
	EASY|NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(3), ALIEN(4),
	     NORMAL|HARD,   SEQUENCE_ALIEN,     BAR(4), ALIEN(4),

	0,					SEQUENCE_END
};

//---------------------------------------------------------------------
// LAYOUTS
//---------------------------------------------------------------------

const ts_level_layout	layout_1 =
{ 
	(u16 *)l1_layout_Palette,
	(u16 *)l1_layout_Tiles, sizeof (l1_layout_Tiles),
	(u16 *)l1_layout_Map,
	(u16 *)l1_layout_bars_start_Bitmap,
	(u16 *)l1_layout_bars_repeat_Bitmap,
	(u16 *)l1_tapper_Bitmap,
	(u16 *)l1_tapper_Palette,
	(u16 *)l1_money_Bitmap,
	(u16 *)l1_money_Palette
};

const ts_level_layout	layout_2 = 
{
	(u16 *)l2_layout_Palette,
	(u16 *)l2_layout_Tiles, sizeof (l2_layout_Tiles),
	(u16 *)l2_layout_Map,
	(u16 *)l2_layout_bars_start_Bitmap,
	(u16 *)l2_layout_bars_repeat_Bitmap,
	(u16 *)l2_tapper_Bitmap,
	(u16 *)l2_tapper_Palette,
	(u16 *)l2_money_Bitmap,
	(u16 *)l2_money_Palette
};

const ts_level_layout	layout_3 =
{
	(u16 *)l3_layout_Palette,
	(u16 *)l3_layout_Tiles, sizeof (l3_layout_Tiles),
	(u16 *)l3_layout_Map,
	(u16 *)l3_layout_bars_start_Bitmap,
	(u16 *)l3_layout_bars_repeat_Bitmap,
	(u16 *)l1_tapper_Bitmap,
	(u16 *)l1_tapper_Palette,
	(u16 *)l1_money_Bitmap,
	(u16 *)l1_money_Palette
};

const ts_level_layout	layout_5 =
{
	(u16 *)l5_layout_Palette,
	(u16 *)l5_layout_Tiles, sizeof (l5_layout_Tiles),
	(u16 *)l5_layout_Map,
	(u16 *)l5_layout_bars_start_Bitmap,
	(u16 *)l5_layout_bars_repeat_Bitmap,
	(u16 *)l1_tapper_Bitmap,
	(u16 *)l1_tapper_Palette,
	(u16 *)l1_money_Bitmap,
	(u16 *)l1_money_Palette
};

//---------------------------------------------------------------------
// LEVELS
//---------------------------------------------------------------------

// Note: x_hoffset == -((x1 - 5) & 7);
// 5 is the offset in *layout_bars_start.bmp
// (see game_bars.c)
const ts_level	levels[LEVEL_MAX] =
{
	{ 	// Level 01 ---------------------------------------------------------
		0,
		level_1_sequence,
		GAME_SPECIAL_ENTERTAINERS_1,
		&layout_1, NO,
		ALIEN(1)|ALIEN(2),
		{
        	//  x_hoffset	x1			x2			y			x_player	y_player		[xy]_tapper		direction
			{ 	-2,			IFIX4(79), 	IFIX4(239), IFIX4(56),	IFIX4(48),	IFIX4(56),		43,	42,			DIRECTION_LEFT  },
			{ 	-0,			IFIX4(61), 	IFIX4(239), IFIX4(80),	IFIX4(30),	IFIX4(77),		25,	63,			DIRECTION_LEFT	},
			{ 	-3,			IFIX4(48), 	IFIX4(239), IFIX4(104),	IFIX4(17),	IFIX4(101),		12,	87,			DIRECTION_LEFT	},
			{ 	-3,			IFIX4(40), 	IFIX4(239), IFIX4(128),	IFIX4(9),	IFIX4(128),		4,	114,		DIRECTION_LEFT	}
		}
	},
	{ 	// Level 02 ---------------------------------------------------------
		1,
		level_2_sequence,
		GAME_SPECIAL_ENTERTAINERS_1,
		&layout_1, NO,
		ALIEN(1)|ALIEN(2)|ALIEN(3),
		{
            //  x_hoffset	x1			x2			y			x_player	y_player		[xy]_tapper		direction
			{ 	-2,			IFIX4(79), 	IFIX4(239), IFIX4(56),	IFIX4(48),	IFIX4(56),		43,	42,			DIRECTION_LEFT  },
			{ 	-0,			IFIX4(61), 	IFIX4(239), IFIX4(80),	IFIX4(30),	IFIX4(77),		25,	63,			DIRECTION_LEFT	},
			{ 	-3,			IFIX4(48), 	IFIX4(239), IFIX4(104),	IFIX4(17),	IFIX4(101),		12,	87,			DIRECTION_LEFT	},
			{ 	-3,			IFIX4(40), 	IFIX4(239), IFIX4(128),	IFIX4(9),	IFIX4(128),		4,	114,		DIRECTION_LEFT	}
		}
	},
	{ 	// Level 03 ---------------------------------------------------------
		2,
		level_3_sequence,
		GAME_SPECIAL_TUBEALIEN,
		&layout_2, NO,
		ALIEN(1)|ALIEN(2)|ALIEN(3)|ALIEN(4),
		{
            //  x_hoffset	x1			x2			y			x_player	y_player		[xy]_tapper		direction
			{ 	-1,			IFIX4(70),	IFIX4(239),	IFIX4(56),	IFIX4(39),	IFIX4(56),		34,	42,		    DIRECTION_LEFT  },
			{ 	-7,			IFIX4(60),	IFIX4(239),	IFIX4(80),	IFIX4(29),	IFIX4(77),		24,	63,       	DIRECTION_LEFT	},
			{ 	-3,			IFIX4(48), 	IFIX4(239),	IFIX4(104),	IFIX4(17),	IFIX4(101),		12, 87,      	DIRECTION_LEFT	},
			{ 	-3,			IFIX4(40),	IFIX4(239),	IFIX4(128),	IFIX4(9),	IFIX4(128),		4,	114,  		DIRECTION_LEFT	}
		}
	},
	{ 	// Level 04 ---------------------------------------------------------
		3,
		level_4_sequence,
		GAME_SPECIAL_TUBEALIEN,
		&layout_2, NO,
		ALIEN(1)|ALIEN(2)|ALIEN(3)|ALIEN(4)|ALIEN(5),
		{
            //  x_hoffset	x1			x2			y			x_player	y_player		[xy]_tapper		direction
			{ 	-1,			IFIX4(70),	IFIX4(239),	IFIX4(56),	IFIX4(39),	IFIX4(56),		34,	42,		    DIRECTION_LEFT  },
			{ 	-7,			IFIX4(60),	IFIX4(239),	IFIX4(80),	IFIX4(29),	IFIX4(77),		24,	63,       	DIRECTION_LEFT	},
			{ 	-3,			IFIX4(48), 	IFIX4(239),	IFIX4(104),	IFIX4(17),	IFIX4(101),		12, 87,      	DIRECTION_LEFT	},
			{ 	-3,			IFIX4(40),	IFIX4(239),	IFIX4(128),	IFIX4(9),	IFIX4(128),		4,	114,  		DIRECTION_LEFT	}
		}
	},
	{ 	// Level 05 ---------------------------------------------------------
		4,
		level_5_sequence,
		GAME_SPECIAL_ENTERTAINERS_2,
		&layout_3, NO,
		ALIEN(2)|ALIEN(3)|ALIEN(4)|ALIEN(5)|ALIEN(6),
		{
            //  x_hoffset	x1				x2			y			x_player			y_player		[xy]_tapper			direction
			{ 	+1,			IFIX4(239-70), 	IFIX4(0), 	IFIX4(56),	IFIX4(240-39-32),	IFIX4(56),		240-34-16,	42,		DIRECTION_RIGHT },
			{ 	+7,			IFIX4(239-60), 	IFIX4(0), 	IFIX4(80),	IFIX4(240-29-32),	IFIX4(77),		240-24-16,	63,		DIRECTION_RIGHT	},
			{ 	+3,			IFIX4(239-48), 	IFIX4(0), 	IFIX4(104),	IFIX4(240-17-32),	IFIX4(101),		240-12-16,	87,		DIRECTION_RIGHT	},
			{ 	+3,			IFIX4(239-40), 	IFIX4(0), 	IFIX4(128),	IFIX4(240-9-32),	IFIX4(128),		240-4-16,	114,	DIRECTION_RIGHT	}
		}
	},
	{ 	// Level 06 ---------------------------------------------------------
		5,
		level_6_sequence,
		GAME_SPECIAL_ENTERTAINERS_2,
		&layout_3, NO,
		ALIEN(6),
		{
            //  x_hoffset	x1				x2			y			x_player			y_player		[xy]_tapper			direction
			{ 	+1,			IFIX4(239-70), 	IFIX4(0), 	IFIX4(56),	IFIX4(240-39-32),	IFIX4(56),		240-34-16,	42,		DIRECTION_RIGHT },
			{ 	+7,			IFIX4(239-60), 	IFIX4(0), 	IFIX4(80),	IFIX4(240-29-32),	IFIX4(77),		240-24-16,	63,		DIRECTION_RIGHT	},
			{ 	+3,			IFIX4(239-48), 	IFIX4(0), 	IFIX4(104),	IFIX4(240-17-32),	IFIX4(101),		240-12-16,	87,		DIRECTION_RIGHT	},
			{ 	+3,			IFIX4(239-40), 	IFIX4(0), 	IFIX4(128),	IFIX4(240-9-32),	IFIX4(128),		240-4-16,	114,	DIRECTION_RIGHT	}
		}
	},
	{ 	// Level 07 ---------------------------------------------------------
		6,
		level_7_sequence, // FIXME: to do
		GAME_SPECIAL_NONE,
		&layout_5, NO,
		ALIEN(1)|ALIEN(4)|ALIEN(5)|ALIEN(6)|ALIEN(7),
		{ // Bars
            //  x_hoffset	x1				x2			y			x_player			y_player		[xy]_tapper			direction
			{ 	+2,			IFIX4(239-79), 	IFIX4(0), 	IFIX4(56),	IFIX4(240-48-32),	IFIX4(56),		240-43-16,	42,		DIRECTION_RIGHT },
			{ 	-0,			IFIX4(61), 	IFIX4(239), IFIX4(80),	IFIX4(30),	IFIX4(80-3),	25,	63,			DIRECTION_LEFT	},
			{ 	+3,			IFIX4(239-48), 	IFIX4(0), 	IFIX4(104),	IFIX4(240-17-32),	IFIX4(104-3),	240-12-16,	87,		DIRECTION_RIGHT	},
			{ 	-3,			IFIX4(40), 	IFIX4(239), IFIX4(128),	IFIX4(9),	IFIX4(128),		4,	114,		DIRECTION_LEFT	}
		},
	},
	{ 	// Level 08 ---------------------------------------------------------
		7,
		level_empty_sequence, // FIXME: to do
		GAME_SPECIAL_NONE,
		&layout_5, NO,
		ALIEN(7),
		{ // Bars
            //  x_hoffset	x1				x2			y			x_player			y_player		[xy]_tapper			direction
			{ 	+2,			IFIX4(239-79), 	IFIX4(0), 	IFIX4(56),	IFIX4(240-48-32),	IFIX4(56),		240-43-16,	42,		DIRECTION_RIGHT },
			{ 	-0,			IFIX4(61), 	IFIX4(239), IFIX4(80),	IFIX4(30),	IFIX4(80-3),	25,	63,			DIRECTION_LEFT	},
			{ 	+3,			IFIX4(239-48), 	IFIX4(0), 	IFIX4(104),	IFIX4(240-17-32),	IFIX4(104-3),	240-12-16,	87,		DIRECTION_RIGHT	},
			{ 	-3,			IFIX4(40), 	IFIX4(239), IFIX4(128),	IFIX4(9),	IFIX4(128),		4,	114,		DIRECTION_LEFT	}
		},
	}
};

//---------------------------------------------------------------------
