//---------------------------------------------------------------------
// SPACE TAPPER: game_entity_beers.h
// by Omar Cornut
//---------------------------------------------------------------------
// Game - Entity - Beers handling
//---------------------------------------------------------------------

// Beers Palette index
#define BEER_PALETTE_IDX            				(1)

// Beers Animations
#define BEER_ANIM_EMPTY								(0)
#define BEER_ANIM_STEP(STEP)						(BEER_ANIM_EMPTY + STEP)
#define BEER_ANIM_STEP_MAX							(6)
#define BEER_ANIM_COMPLETE							(6)
#define BEER_ANIM_FILLING							(7)
#define BEER_ANIM_BREAKING_LEFT       				(8)
#define BEER_ANIM_BREAKING_RIGHT					(9)
#define BEER_ANIM_DRINKING(N)	    				(10+(N))

// Beers Sprite informations
#define	BEER_SPR_SIZE_X								(8)
#define	BEER_SPR_SIZE_Y								(16)
#define	BEER_SPR_OFFSET_PLAYER_X					(+4)
#define	BEER_SPR_OFFSET_PLAYER_Y					(+32)
#define BEER_SPR_OFFSET_BAR_X						(IFIX4(10))
#define BEER_SPR_OFFSET_BAR_Y						(IFIX4(-3))
#define BEER_LENGTH_BARX1_TO_CRASH_LEFT				(IFIX4(6))
#define BEER_LENGTH_BARX2_TO_CRASH_RIGHT			(IFIX4(8))

// Miscellaneous
#define	BEER_SPEED_THROWN							(FFIX4(3.0))
#define	BEER_SPEED_RETURNED_NORMAL					(FFIX4(1.0))
#define	BEER_SPEED_RETURNED_FAST					(FFIX4(2.0))
#define BEER_SPEED_CRASH_LEFT_X						(FFIX4(1.0))
#define BEER_SPEED_CRASH_LEFT_Y						(FFIX4(1.300))
#define	BEER_FILLED_MAX								(18) /* 18 */

// Beers States
#define BEER_STATE_FILLING							(0)
#define BEER_STATE_THROWN							(1)
#define BEER_STATE_DRINKING							(2)
#define BEER_STATE_RETURNING						(3)
#define BEER_STATE_FALLING_LEFT						(4)
#define BEER_STATE_FALLING_RIGHT					(5)
#define BEER_STATE_HEAVY_DRINKER_THROWN             (6)

// Beers Sub States
#define BEER_SUB_STATE_FALLING_LEFT_INIT			(0)
#define BEER_SUB_STATE_FALLING_LEFT_FALL			(1)
#define BEER_SUB_STATE_FALLING_LEFT_CATCHED			(2)
#define BEER_SUB_STATE_FALLING_LEFT_CRASH_INIT		(3)
#define BEER_SUB_STATE_FALLING_LEFT_CRASH			(4)
#define BEER_SUB_STATE_FALLING_LEFT_CRASH_DELAY		(5)
#define BEER_SUB_STATE_FALLING_RIGHT_INIT 			(0)
#define BEER_SUB_STATE_FALLING_RIGHT_CRASH			(1)
#define BEER_SUB_STATE_FALLING_RIGHT_DELAY 			(2)

//---------------------------------------------------------------------

void            beers_init_videodata(void);

//---------------------------------------------------------------------

t_entity *		beer_new(int bar_idx, int x, int y);
void			beer_delete(t_entity *beer);
void			beer_update(t_entity *beer);

//---------------------------------------------------------------------

int				beer_collide_with_player(t_entity *beer);
void			beer_player_throw(t_entity *beer);
void			beer_customer_return(t_entity *beer, fs16 speed);
void			beer_player_catch(t_entity *beer);
void            beer_customer_heavy_drinker_throw_back(t_entity *beer);

//---------------------------------------------------------------------
