//---------------------------------------------------------------------
// SPACE TAPPER: game_levels.h
// by Omar Cornut
//---------------------------------------------------------------------
// Game - Levels
//---------------------------------------------------------------------

//---------------------------------------------------------------------
// STRUCTURES
//---------------------------------------------------------------------

typedef struct
{
	u16 *					layout_palette;
	u16 *					layout_tiles;
	int						layout_tiles_size;
	u16 *					layout_map;
	u16 *					layout_bars_start;
	u16 *					layout_bars_repeat;
	u16 *					tappers_tiles;
	u16 *					tappers_palette;
	u16 *					money_tiles;
	u16 *					money_palette;
}							ts_level_layout;

typedef struct
{
	u16						level_idx;
	const u8 *				sequence;
	int						special;
	const ts_level_layout *	layout;
	int						layout_map_x_flipped;
	int                     aliens_used;
	t_bar 					bars[BAR_MAX];
}							ts_level;

//---------------------------------------------------------------------
// FUNCTIONS
//---------------------------------------------------------------------

// FUNCTION: level_start(int level)
// Start given level
void			level_start(int level_idx);

//---------------------------------------------------------------------

