//---------------------------------------------------------------------
// SPACE TAPPER: game_misc.c
// by Omar Cornut
//---------------------------------------------------------------------
// Game - Miscellaneous Stuff
//---------------------------------------------------------------------

#include "tapper.h"

//---------------------------------------------------------------------
// DATA
//---------------------------------------------------------------------

// Crashing Effect: table of the Y offsets
const s8	crash_scrolly_table[CRASH_STEP_MAX] = 
{
	0, -2, +4, -3, +2, -1, -1, +1
};

// Lives Tiles Start
static int      lives_tiles_start;

//---------------------------------------------------------------------
// FUNCTION
//---------------------------------------------------------------------

void		crash_do_step(int step)
{
	int		y_offset;
	
	y_offset = crash_scrolly_table[step];
	game.bg0.scroll_y += y_offset;
	game.bg1.scroll_y += y_offset;
	background_sync_scroll(&game.bg0);
	background_sync_scroll(&game.bg1);
	tappers_sprites_move_y(-y_offset);
}

//---------------------------------------------------------------------

void		lives_init_videodata(void)
{
    lives_tiles_start = vram_obj_copy((u16 *)lives_Bitmap, 1 /* 5 */ * TILE_SIZE_16);
}

void		lives_init(void)
{
	int		i;
	int		sprite_idx;
	int		x = RES_WIDTH - 12;
	
	for (i = game.state.lives; i > 0; i--)
	{
		sprite_idx = sprite_new(1);
		sprites[sprite_idx].oam.attr0 = SPR_A0_COLOR_16 | SPR_A0_SHAPE_SQUARE | SPR_A0_Y_Set(3);
		sprites[sprite_idx].oam.attr1 = SPR_A1_SIZE_8 | SPR_A1_X_Set(x);
		sprites[sprite_idx].oam.attr2 = SPR_A2_PRIORITY_Set(1) | SPR_A2_CHAR_Set(lives_tiles_start) | SPR_A2_PALETTE_Set(LIVES_PALETTE_IDX);
		x -= 10;
	}
	/*
	lives_sprite_idx = sprite_new(1);
	sprites[lives_sprite_idx].oam.attr0 = SPR_A0_COLOR_16 | SPR_A0_SHAPE_SQUARE | SPR_A0_Y_Set(3);
	sprites[lives_sprite_idx].oam.attr1 = SPR_A1_SIZE_16 | SPR_A1_X_Set(RES_WIDTH - 27);
	sprites[lives_sprite_idx].oam.attr2 = SPR_A2_PRIORITY_Set(1) | SPR_A2_CHAR_Set(lives_tiles_start + 1) | SPR_A2_PALETTE_Set(LIVES_PALETTE_IDX);
	font_bg_printf(&game.bg3, game.font_tiles_start, 28, 1, "%01d", game.state.lives);
	*/
}

//---------------------------------------------------------------------
