//---------------------------------------------------------------------
// GBALIB: cos_sin_make.c
// by Omar Cornut
//---------------------------------------------------------------------
// Cosinus & Sinuse Table Maker
// (for development host)
//---------------------------------------------------------------------

// FIXME: this executable do not actually produce the exact cos_sin.[ch] files

#include <stdio.h>
#include <math.h>

typedef unsigned short FIXED;

int				main(int argc, char **argv)
{
	int			i, x;
	FILE *		f;
	
	if ((f = fopen("cos_sin.c", "wt")) == NULL)
	{
		perror("fopen");
		return (1);
	}

	fprintf(f, "//---------------------------------------------------------------------""\n");
	fprintf(f, "// GBALIB: cos_sin.c"													"\n");
	fprintf(f, "// by Omar Cornut"														"\n");
	fprintf(f, "//---------------------------------------------------------------------""\n");
	fprintf(f, "// Cosinus & Sinuse Table"												"\n");
	fprintf(f, "//---------------------------------------------------------------------""\n");
	fprintf(f, "\n");

	fprintf(f, "const FIXED16 cos_sin_table[256 + 64] = \n{\n  ");
	
	x = 0;
	for (i = 0; i < 256 + 64; i++)
	{
		if (i == 0)
			{ fprintf(f, "// Sinuse Table Starts Here\n  "); x = 0; }
		if (i == 64)
			{ fprintf(f, "// Cosinus Table Starts Here (+ 64)\n  "); x = 0; }
		if (i == 256)
			{ fprintf(f, "// Sinuse Table Ends Here\n  "); x = 0; }
		{
			float v_float = sin((float)i / (float)128 * M_PI);
			FIXED v_fixed = v_float * 256;
			fprintf(f, "0x%04X, ", v_fixed);
		}
		if (++x == 8)
		{
			fprintf(f, "\n  ");
			x = 0;
		}
		if (i == 256 + 63)
			{ fprintf(f, "// Cosinus Table Ends Here\n"); x = 0; }
	}
	fprintf(f, "};\n");
	
	fclose(f);
	
	return (0);
}
