//---------------------------------------------------------------------
// GBALIB: debug.h
// by Omar Cornut
//---------------------------------------------------------------------
// Debugging Facilities
//---------------------------------------------------------------------
// Currently only implement	dprint()/dprintf() for Mappy emulator
//---------------------------------------------------------------------

#include "gbalib.h"

//---------------------------------------------------------------------

#ifdef DEBUG

// FUNCTION: dprint()
// Output a	string
void	dprint(const char *str)
{
#if defined(DEBUG_MAPPY)
	asm	volatile(
		"mov r2, %0\n"
		"ldr r0, =0xc0ded00d\n"
		"mov r1, #0\n"
		"and r0, r0, r0\n"
		: /* No	output */ :	"r"	(str) :	"r0", "r1",	"r2");
#elif defined(DEBUG_VBA)
    asm volatile(
    	"mov r0, %0;"
        "swi 0xff;"
        : /* No output */ : "r" (str) : "r0");
#else
#error "No kind of code specified for outputting strings"
#endif
}

// FUNCTION: dprintf()
// Output a	formatted string. Call dprint()
void	dprintf(const char *format,	...)
{
	va_list	args;
	char	buf[256]; /* Do	we care	about security on a	GBA	? :) */
	
	va_start(args, format);
	mvsprintf(buf, format, args);
	dprint(buf);
	va_end(args);
}

#endif /* DEBUG	*/

//---------------------------------------------------------------------
