//---------------------------------------------------------------------
// GBALIB: gbalib.h
// by Omar Cornut
// Last Updated 2002.06.07
//---------------------------------------------------------------------
// General purpose library for GBA
// Main include file
//---------------------------------------------------------------------

#ifndef __GBALIB_H__
#define __GBALIB_H__

#define GBALIB_NAME				"GBA-Lib"
#define GBALIB_AUTHOR			"Omar Cornut"
#define GBALIB_DATE				"2002.08.10"
#define GBALIB_VERSION			GBALIB_DATE

#include <stdarg.h>				// Standard arguments macros

#include "gba.h"				// Basic types, GBA Registers and GBA Defines

#include "fixed.h"				// Fixed Point
#include "cos_sin.h"			// Cos & Sinus Tables

#include "dma.h"				// DMA
#include "timer.h"              // Timer
#include "syscall.h"            // System Calls
#include "intrs.h"				// Interrupts
#include "intrs_vcount.h"		// Interrupts - V-Count handler

#include "background.h"			// Background
#include "boundingbox.h"		// Bounding Box
#include "font.h"				// Font
#include "palette.h"            // Palette
#include "sprites.h"			// Sprites
#include "vram.h"				// VRAM
#include "windows.h"            // Windows
#include "anim.h"				// Animations

#include "msprintf.h"			// Mini-sprintf
#include "debug.h"				// Debugging Features
#include "profile.h"            // Profiling Features

#endif /* __GBA_LIB_H__ */

//---------------------------------------------------------------------
