//---------------------------------------------------------------------
// GBALIB: palette.h
// by Omar Cornut
//---------------------------------------------------------------------
// Palette Manager
//---------------------------------------------------------------------
// Simple helper functions to copy palettes data.
//---------------------------------------------------------------------

//---------------------------------------------------------------------
// PALETTE ENTRY STRUCTURE
//---------------------------------------------------------------------
// Note: this structure is not actually used much in the code, since C
// disallow some manipulations with structures.

typedef struct __attribute__((packed))
{
    union
    {
        struct
        {
            u16 r       :5; // Red
            u16 g       :5; // Green
            u16 b       :5; // Blue
            u16 unused  :1; // Unused
        };
        struct
        {
            u16 value;      // 16-bit value
        };
    };
}               t_color;

//---------------------------------------------------------------------
// FUNCTIONS
//---------------------------------------------------------------------

// FUNCTION: palette_copy(u16 *src, u16 *dst)
// Copy an arbitrary number of color
void    palette_copy(u16 *src, u16 *dst, int colors);

// FUNCTION: palette_copy_16(u16 *src, u16 *dst)
// Copy a 16 colors palette
void    palette_copy_16(u16 *src, u16 *dst);

// FUNCTION: palette_copy_256(u16 *src, u16 *dst)
// Copy a 256 colors palette
void    palette_copy_256(u16 *src, u16 *dst);
