//---------------------------------------------------------------------
// GBALIB: profile.c
// by Omar Cornut
//---------------------------------------------------------------------
// Profiling Features
//---------------------------------------------------------------------

#include "gbalib.h"

#ifdef PROFILE

// USER REDEFINABLE INCLUDE!!!
#include "../tapper.h"

//---------------------------------------------------------------------
// DATA
//---------------------------------------------------------------------

typedef struct
{
    int         desc;
    int         value;
}               t_profile_value;

static int              profile_pos;
static t_profile_value  profile_values[PROFILE_BUFFER_SIZE];

//---------------------------------------------------------------------
// FUNCTIONS
//---------------------------------------------------------------------

void            profile_start(void)
{
    profile_pos = 0;
}

void            profile_now2(int desc)
{
    profile_values[profile_pos].desc = desc;
    profile_values[profile_pos++].value = PROFILE_VALUE;
}

void            profile_print(void)
{
    int         i;
    int         x = PROFILE_POS_X;
    int         y = PROFILE_POS_Y;
    char        str[32];
    
    for (i = 0; i < profile_pos; i++)
    {
        msprintf(str, "%4.4s %03d", (char *)&profile_values[i].desc, profile_values[i].value);
        PROFILE_PRINT(x, y, str);
        x += PROFILE_POS_X_INC;
        y += PROFILE_POS_Y_INC;
    }
    for (; i < PROFILE_BUFFER_SIZE; i++)
    {
        PROFILE_PRINT(x, y, "        ");
        x += PROFILE_POS_X_INC;
        y += PROFILE_POS_Y_INC;
    }
}

//---------------------------------------------------------------------

#endif /* #ifdef PROFILE */
