//---------------------------------------------------------------------
// GBALIB: window.c
// by Omar Cornut
//---------------------------------------------------------------------
// Window Handling System
//---------------------------------------------------------------------

#include "gbalib.h"

//---------------------------------------------------------------------
// DATA
//---------------------------------------------------------------------

t_windows   windows;

//---------------------------------------------------------------------
// FUNCTIONS
//---------------------------------------------------------------------

// FUNCTION: windows_init()
// Initialize windows handling system
// FIXME: it is really necessary to initialize default values ?
void		windows_init(void)
{
    // In & Out
    windows.win0.in.reg     = REG_WININ_DISP_ALL | REG_WININ_COLOR_EFFECTS;
    windows.win1.in.reg     = REG_WININ_DISP_ALL | REG_WININ_COLOR_EFFECTS;
    windows.winobj_in.reg   = REG_WININ_DISP_ALL | REG_WININ_COLOR_EFFECTS;
    windows.wins_out.reg    = REG_WINOUT_WIN01_DISP_NONE;
    
    // Positionning
    windows.win0.coord.x1   = 0;
    windows.win0.coord.y1   = 0;
    windows.win0.coord.x2   = RES_WIDTH - 1;
    windows.win0.coord.y2   = RES_HEIGHT - 1;
    windows.win1.coord.x1   = 0;
    windows.win1.coord.y1   = 0;
    windows.win1.coord.x2   = RES_WIDTH - 1;
    windows.win1.coord.y2   = RES_HEIGHT - 1;
}

// FUNCTION: windows_sync()
// Synchronize shadow windows registers data with hardware
void		windows_sync(void)
{
    // In & Out
    REG_WININ = windows.win0.in.reg | (windows.win1.in.reg << 8);
    REG_WINOUT = windows.wins_out.reg | (windows.winobj_in.reg << 8);
    
    // Positionning
    REG_WIN0H = windows.win0.coord.x;
    REG_WIN1H = windows.win1.coord.x;
    REG_WIN0V = windows.win0.coord.y;
    REG_WIN1V = windows.win1.coord.y;
}

