//---------------------------------------------------------------------
// SPACE TAPPER: tapper.c
// by Omar Cornut
//---------------------------------------------------------------------
// Main File
//---------------------------------------------------------------------

#include "tapper.h"
//volatile const int __gba_multiboot;

//---------------------------------------------------------------------

void	fatal(char *msg)
{
	REG_DISPCNT = REG_DISPCNT_MODE_0 | REG_DISPCNT_OBJ_MAP_1D | REG_DISPCNT_OBJ_ENABLE;
	#ifdef DEBUG
		dprint(msg);
	#endif
	while (1)
	{ /* ... */ }
}

//---------------------------------------------------------------------

void    font_init_videodata(void)
{
    // Setup fixed palette with black & white
	MEM_PAL_BG[0] = RGB16(0, 0, 0);     /* 0: Transparent   */
	MEM_PAL_BG[1] = RGB16(0, 0, 0);     /* 1: Fixed black   */
	MEM_PAL_BG[2] = RGB16(31, 31, 31);  /* 2: Fixed white   */

	// Setup fixed font at beginning of VRAM
	vram_bg_start(REG_BGxCNT_CHAR_BASE_Addr(0));
    game.font_tiles_start = vram_bg_copy((u16 *)font_Bitmap, sizeof (font_Bitmap)) - 32;
}

//---------------------------------------------------------------------

int		main(void)
{
start:
	// Setup video mode 0, disable all display
	REG_DISPCNT = REG_DISPCNT_MODE_0 | REG_DISPCNT_OBJ_MAP_1D;
	
	// Clear sprites
	sprites_clear();

	// Initialize Interrupts System
	intrs_init();
	intrs_cpu_disable();
    
	// Start with title screen
    sections_init();
	section_jump(SECTION_INTERFACE_TITLE_SCREEN);

	// Main frame-based loop, everything is done there
	while (TRUE)
	{
		while (REG_VCOUNT < RES_HEIGHT) { }	// Wait for V-Blank	// FIXME: use system call
		if (inputs_read())					// Read Inputs
			goto start;
		#ifdef DEBUG
			if ((game.keys & REG_KEYINPUT_KEY_SELECT) && !(game.keys_old & REG_KEYINPUT_KEY_SELECT))
				entities_print();
		#endif	
		sections.current->data->f_update();	// Update Game Section/Logic
		sprites_copy();						// Copy Sprites to OAM
		while (REG_VCOUNT > 1) { }			// Wait for new frame
	}

	return (0);
}

//---------------------------------------------------------------------
